%load the test image
img=imread('cat.png');

%load GreyBall groundtruth
gb=load('gb.mat');
gb=gb.gb;

%calculate GreyBall groundtruth chromaticities
ch1=gb./repmat(sum(gb, 2), 1, 3);

%load all GreyBall histograms with 2 bins per channel
histograms2=load('gb_histograms_2.txt');
%load all GreyBall histograms with 3 bins per channel
histograms3=load('gb_histograms_3.txt');

histograms=cell(2, 1);
histograms{1}=histograms2;
histograms{2}=histograms3;
%learn Color Cat parameters
[bestIdx, line, x1, x2, pcaMatrix, r, reduction]=trainColorCat(ch1, histograms);

n=bestIdx+1;
%perform illumination estimation
illuminationEstimation=colorCat(img, n, line, x1, x2, pcaMatrix, r, reduction);

%perform simple chromatic adaptation
img2=scaleChannels(img, [1, 1, 1]./illuminationEstimation);

figure;
imshow(img);
title('The original image');

figure;
imshow(img2);
title('Corrected image');
